<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesTeacherProxy extends \Entities\Teacher implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function login($login = NULL)
    {
        $this->__load();
        return parent::login($login);
    }

    public function name($name = NULL)
    {
        $this->__load();
        return parent::name($name);
    }

    public function addLesson(\Entities\Lesson $lesson)
    {
        $this->__load();
        return parent::addLesson($lesson);
    }

    public function lessons()
    {
        $this->__load();
        return parent::lessons();
    }

    public function addGroup(\Entities\AuthGroup $group)
    {
        $this->__load();
        return parent::addGroup($group);
    }

    public function groups()
    {
        $this->__load();
        return parent::groups();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'login', 'name', 'lessons', 'groups');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}